# -*- coding: utf-8 -*-
"""
Created on Mon Oct  1 19:11:12 2018

@author: bcasabone
"""

from utils import LoadCSV, FindIndexCloseToVal  as fic

import pandas as pd
import matplotlib.pyplot as plt
import numpy as np

import pathlib
path=str(pathlib.Path().absolute())


#%%
plt.rcParams.update({'font.size': 12})    
trans =  LoadCSV(path + "/1535-780 trans lock.csv")


#whole 
x = trans[0]
y1 = trans[1]
y1_max = max(y1)
y2 = trans[3]
y2_max = max(y2)
y1_rms = np.mean(y1) - np.sqrt(np.mean(y1**2))
y1_std = np.std(y1)

plt.figure(1, figsize=(10,3.5))
plt.clf()
plt.subplot(143)
plt.plot(x,y1, "r-", label='780 nm', linewidth=0.05)
plt.plot(x,y2, "b-", label='1535 nm',linewidth=0.05)
plt.ylim((-0.03,0.26))
plt.xlabel('Time (s)')
max_noise_subs=(np.max(y2) - 0.005)
mean = np.mean(y2)
print("mean value of the 1535: " + str(mean))
print("max value of the 1535 - noise of detector: " + str(max_noise_subs))
print("porcentage:" + str(mean/max_noise_subs))

#plt.text(-2.8, 0.23, "b)", fontsize=12)
#plt.title('Lock on - several cycles of cryo pump')


#zoomed area
x0 = fic(trans[0], 1.275)
x1 = fic(trans[0], 1.3)
x =  trans[0][x0:x1]
y1 = trans[1][x0:x1] 
y2 = trans[3][x0:x1] 
y1_zoom_rms = np.mean(y1) - np.sqrt(np.mean(y1**2))
y1_zoom_std = np.std(y1)
plt.subplot(144)
plt.plot((x-1.275)*1e3,y1, "r-", label='780 nm', linewidth=0.5)
plt.plot((x-1.275)*1e3,y2, "b-", label='1535 nm', linewidth=0.5)
plt.ylim((-0.03,0.26))
plt.xlabel('Time (ms)')
#plt.text(0, 0.23, "c)", fontsize=12)
#plt.ylabel('Transmission (au)')
#plt.title('Lock - quietest part of cycle of cryopump')


#FSR
fsrs = LoadCSV(path + "/1535-780 fsrs.csv")
x = fsrs[0]
x0 = fic(fsrs[0], -0.02)
x1 = fic(fsrs[0], 0.0075)
x = fsrs[0][x0:x1]
y1 = fsrs[1][x0:x1] *0.25
y2 = fsrs[3][x0:x1] *y2_max
x=x-min(x)
x=x/max(x)
x=x*780/2*5
plt.subplot(141)
plt.plot(np.array(x)+2,y1,"r-", label='780 nm', linewidth=0.5)
plt.plot(x,y2,"b-", label='1535 nm',linewidth=0.5)
plt.xlim((1015,1830))
plt.legend()
plt.xlabel('Cavity lenght (nm)')
plt.ylabel('Transmission (au)')
plt.ylim((-0.03,0.26))

zero_std=np.std(y2)
print("std value of the zero transmission: " + str(np.std(y2)))



x = fsrs[0]
x0 = fic(fsrs[0], -0.02)
x1 = fic(fsrs[0], 0.0075)
x = fsrs[0][x0:x1]
y1 = fsrs[1][x0:x1] *0.25
y2 = fsrs[3][x0:x1] *y2_max
x=x-min(x)
x=x/max(x)
x=x*780/2*5
plt.subplot(142)
plt.plot(np.array(x)+2,y1,"r-", label='780 nm', linewidth=0.5)
plt.plot(x,y2,"b-", label='1535 nm',linewidth=0.5)
plt.xlim((1047.9,1051))
plt.xlabel('Cavity lenght (nm)')
plt.ylim((-0.03,0.26))



#plt.title('Free spectral range')
#plt.text(0, 0.23, "a)", fontsize=12)



fwhm_780=177.025-177.674
fsr_780=177.52-634.6
finesse_780 = fsr_780/fwhm_780
print("Finesse at 780 = " + str(finesse_780))

fwhm_1535_1=202.426-202.636
fwhm_1535_2=.17-.36
fwhm_1535 = np.mean([fwhm_1535_1, fwhm_1535_2])
finesse_1535 = 2*fsr_780 / fwhm_1535
print("Finesse at 1535 = " + str(finesse_1535))


v_to_nm = 780/2/finesse_780

dis_rms=abs(v_to_nm*y1_rms/y1_max)
dis_zoom_rms=abs(v_to_nm*y1_zoom_rms/y1_max)

dis_std=abs(v_to_nm*y1_std/y1_max)
dis_zoom_std=abs(v_to_nm*y1_zoom_std/y1_max)



print("dis_rms: " + str(dis_rms*1000) + " pm" )
print("dis_zoom_rms: " + str(dis_zoom_rms*1000) + " pm" )
print("dis_std: " + str(dis_std*1000) + " pm" )
print("dis_zoom_std: " + str(dis_zoom_std*1000) + " pm" )

plt.tight_layout()
plt.savefig("sm_780_1535_lock_trace.png", dpi=300)

#%%

fft = LoadCSV(path + "/780 fft.csv")
x = fft[0]
y = fft[1]
x1 = fic(fsrs[0], 0.0075)
plt.figure(2)
plt.clf()
plt.loglog(x,y)
plt.xlabel('Freq. (Hz)')
plt.ylabel('Amplitud')


#%%


import numpy as np
import matplotlib.pyplot as plt
import scipy.fftpack

trans =  LoadCSV(r"z:\Experiments\Single REI\2018\09 - sept\lock 780 and 1535 cryo on\1535-780 trans lock.csv")

#whole 
x = trans[0]
y = trans[1]

# Number of samplepoints
N = len(y)
# sample spacing
T =x[1] - x[0]
x = np.linspace(0.0, N*T, N)
yf = scipy.fftpack.fft(y)
xf = np.linspace(0.0, 1.0/(2.0*T), N/2)

fig, ax = plt.subplots()
ax.loglog(xf, 2.0/N * np.abs(yf[:N//2]))
plt.xlabel('Freq. (Hz)')
plt.ylabel('Amplitud')


